package at.hl.okb.wsclient;

import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import at.hl.okb.wsclient.Exception.OKBWebServiceFailedException;
import at.hl.wsclient.okb.AddAlgorithm;
import at.hl.wsclient.okb.Algorithm;
import at.hl.wsclient.okb.ArrayOfAlgorithm;
import at.hl.wsclient.okb.ArrayOfDataType;
import at.hl.wsclient.okb.DataType;
import at.hl.wsclient.okb.IOKBService;
import at.hl.wsclient.okb.OKBService;
import at.hl.wsclient.okb.ObjectFactory;
import at.hl.wsclient.okb.Platform;

/**
 * @author HolperM
 * 
 */
public class OKBClientTest {

	OKBService srv = null;
	IOKBService port = null;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		this.srv = new OKBService();
		this.port = srv.getWSHttpBindingIOKBService1();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void AddAlgorithmTest() throws Exception {

		ObjectFactory fac = new ObjectFactory();
		AddAlgorithm addA = fac.createAddAlgorithm();
		addA.setDto(fac.createAddAlgorithmDto(fac.createAlgorithm()));
		Long retval = 0L;
		
//		if (port.getAlgorithm(2L)!=null)
//			port.deleteAlgorithm(2L);
		

		Algorithm a = fac.createAlgorithm();
		a.setAlgorithmClassId(1L);
		a.setDescription(fac.createNamedOKBItemDescription("a new Algo"));
		a.setId(2L);
		a.setName(fac.createNamedOKBItemName("Algorithm Name 6"));
		a.setPlatformId(1L);
		try {
			retval = port.addAlgorithm(a);
		} catch (Exception e) {
			throw new OKBWebServiceFailedException(e.getMessage());
		}
		assertTrue("Algortihm wasn't added", retval > 0);
	}

	@Test
	public void GetAlgorithmsTest() {

		ArrayOfAlgorithm algos = port.getAlgorithms();

		for (Algorithm algo : algos.getAlgorithm()) {
			System.out.println("algo ClassId:=" + algo.getAlgorithmClassId());
			System.out.println("algo Id:=" + algo.getId());
			System.out.println("algo PlattformId:=" + algo.getPlatformId());
			System.out.println("algo Class:=" + algo.getClass());
			System.out.println("algo Description:="
					+ algo.getDescription().getValue());
			System.out.println("algo Name:=" + algo.getName().getValue());
		}
		assertTrue("No Algorithms found!", algos.getAlgorithm().size() > 0);
	}

	@Test
	public void GetDataTypesTest() {

		ArrayOfDataType dataTypes = port.getDataTypes();

		for (DataType dataType : dataTypes.getDataType()) {
			System.out.println("algo Id:=" + dataType.getId());
			System.out.println("algo platformId:=" + dataType.getPlatformId());
			System.out.println("algo Name:=" + dataType.getName());
			System.out.println("algo Class:=" + dataType.getClass());
			System.out.println("algo SQLName:="
					+ dataType.getSqlName().getValue());
		}
		assertTrue("No dataTypes found!", dataTypes.getDataType().size() > 0);
	}

	@Test
	public void GetPlatFormTest() {
		Platform f = port.getPlatform(1L);
		assertTrue(f.getName().getValue().length() > 0);
	}

	OKBServiceClient client = new OKBServiceClient();

	@Test
	public void testGetPlatform() {
		client.getPlatformId("ECJ");
	}
	
	
}
